unit AddNewSubVersion;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, UITypes,
  Dialogs, DB, ADODB, StdCtrls;

type
  TFormNewSubVersion = class(TForm)
    ButtonAdd: TButton;
    ButtonClose: TButton;
    GroupBox1: TGroupBox;
    LabelSubVersion: TLabel;
    Label1: TLabel;
    EditName: TEdit;
    EditRegSeed: TEdit;
    ADOConnection: TADOConnection;
    ADOQuery: TADOQuery;
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonAddClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ProjectID: Integer;
    procedure SQLAddNewProjectSubVersion(ProjectID: Integer; SubVersionName: String; VerCodeSeed: String);
  end;

var
  FormNewSubVersion: TFormNewSubVersion;

implementation

{$R *.dfm}

Uses
    Main,
    Settings;

procedure TFormNewSubVersion.ButtonAddClick(Sender: TObject);
begin
    Screen.Cursor := crAppStart;
    try
        SQLAddNewProjectSubVersion(ProjectID, EditName.Text, EditRegSeed.Text);
        Screen.Cursor := crDefault;
        MessageDlg('Successfully created new project sub version "' + EditName.Text + '".', mtConfirmation, [mbOk], 0);
    except
        on E: Exception do begin
            Screen.Cursor := crDefault;
            MessageDlg('Error: ' + E.Message, mtError, [mbOk], 0);
        end;
    end;
end;

procedure TFormNewSubVersion.ButtonCloseClick(Sender: TObject);
begin
    Close;
end;

procedure TFormNewSubVersion.SQLAddNewProjectSubVersion(ProjectID: Integer; SubVersionName: String; VerCodeSeed: String);
begin

    ADOConnection.Close;

    ADOConnection.ConnectionString := FormSettings.EditMySQLConnectionString.Text;

    ADOQuery.SQL.Clear;

    //* Set to use our new database (specified by name)
    ADOQuery.SQL.Add('USE ' + FormSettings.EditDatabaseNameToUse.Text + ';');

    //* Insert a new record
    ADOQuery.SQL.Add('INSERT INTO ' + TN_PROJECTS_SUBVERSION);
    ADOQuery.SQL.Add('(' + CN_PROJECT_ID + ', ' + CN_SUBVERSION_NAME + ', ' + CN_SUBVERSION_VERCODE_SEED + ') VALUES (:a, :b, :c)');
    //* Specify the values and their data type ftWideString = unicode
    ADOQuery.Parameters.ParamByName('a').DataType := ftInteger;
    ADOQuery.Parameters.ParamByName('a').Value := ProjectID;
    ADOQuery.Parameters.ParamByName('b').DataType := ftWideString;
    ADOQuery.Parameters.ParamByName('b').Value := SubVersionName;
    ADOQuery.Parameters.ParamByName('c').DataType := ftString;
    ADOQuery.Parameters.ParamByName('c').Value := VerCodeSeed;

    ADOQuery.ExecSql;

    ADOConnection.Close;

end;

end.
